#version 150 core

uniform int mode;

uniform mat4 boneMatrices[60];

uniform mat4 smMatrix;
uniform mat4 lpvMatrix;

uniform mat4 pMatrix;
uniform mat4 vMatrix;
uniform mat4 mMatrix;
uniform mat3 normalMatrix;

uniform vec3 cameraPos;
uniform vec3 lightPos;

uniform vec3 light_ambient;
uniform vec3 light_diffuse;
uniform vec3 light_specular;

in vec4 vertPos;
in vec3 vertNormal;
in vec2 vertUv;
in vec3 vertColor;
in vec4 boneWeight;
in vec4 boneIndex;

smooth out vec2 UV;
smooth out vec3 N;
smooth out vec3 E;
smooth out vec3 L;
smooth out vec4 smCoord;

void main(void){
	vec4 outBoneWeight = boneWeight;
	outBoneWeight.w = 1.0 - dot(boneWeight.xyz, vec3(1.0f, 1.0f, 1.0f));

	mat4 transformMatrix = outBoneWeight.x * boneMatrices[int(boneIndex.x)];
	transformMatrix += outBoneWeight.y * boneMatrices[int(boneIndex.y)];
	transformMatrix += outBoneWeight.z * boneMatrices[int(boneIndex.z)];
	transformMatrix += outBoneWeight.w * boneMatrices[int(boneIndex.w)];
	
	vec4 newPosition = transformMatrix * vertPos;
	vec4 newNormal = transformMatrix * vec4(vertNormal, 0.0f);
	
	mat4 mvpMatrix = pMatrix * vMatrix * mMatrix;

	gl_Position = mvpMatrix * newPosition;
}
